# FlameGraphs

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://timholy.github.io/FlameGraphs.jl/stable)
[![Build Status](https://github.com/timholy/FlameGraphs.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/timholy/FlameGraphs.jl/actions/workflows/ci.yml)
[![PkgEval][pkgeval-img]][pkgeval-url]
[![Codecov](https://codecov.io/gh/timholy/FlameGraphs.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/timholy/FlameGraphs.jl)

FlameGraphs is a package that adds functionality to Julia's `Profile` standard library. It is directed primarily at the algorithmic side of producing [flame graphs](http://www.brendangregg.com/flamegraphs.html), but includes some "format agnostic" rendering code.

You might use FlameGraphs on its own, but users should consider one of its downstream packages:

- [ProfileView](https://github.com/timholy/ProfileView.jl), a graphical user interface (GUI) based on [Gtk](https://github.com/JuliaGraphics/Gtk.jl) for displaying and interacting with flame graphs
- [PProf](https://github.com/JuliaPerf/PProf.jl), an interactive, web-based profile GUI explorer, implemented as a wrapper around [`google/pprof`](https://github.com/google/pprof). Has excellent support for interaction, filtering, aggregation, and viewing source code. But note that it loses the sample ordering information captured in FlameGraphs.
- [Juno](https://junolab.org/), a development environment that supports profile visualization
- [ProfileVega](https://github.com/davidanthoff/ProfileVega.jl), the recommended package for display in Jupyter notebooks
- [ProfileSVG](https://github.com/timholy/ProfileSVG.jl), a package for writing flame graphs to SVG format
- [ProfileCanvas](https://github.com/pfitzseb/ProfileCanvas.jl), which exports the [profile viewer from the VSCode extension](https://www.julia-vscode.org/docs/stable/userguide/profiler/) to the REPL and Pluto 

See the documentation for details.

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/F/FlameGraphs.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html

using Documenter, FlameGraphs

makedocs(;
    modules=[FlameGraphs],
    format=Documenter.HTML(;
        assets = ["assets/favicon.ico"],
        canonical = "https://timholy.github.io/FlameGraphs.jl/stable/",
    ),
    pages=[
        "Home" => "index.md",
        "Reference" => "reference.md",
    ],
    sitename="FlameGraphs.jl",
    authors="Tim Holy <tim.holy@gmail.com>",
    checkdocs=:exported,
)

deploydocs(;
    repo="github.com/timholy/FlameGraphs.jl",
    push_preview=true,
)

"""
    StackFrameCategory(modcat=FlameGraphs.default_modcat,
                       loccat=FlameGraphs.default_loccat,
                       colorbg=colorant"white",
                       colorfont=colorant"black")

Colorize stackframes based on their category.

`modcat(mod::Module)` should return a color based on the stackframe's module, or `nothing`
if it cannot categorize the stack frame based on the module.

`loccat(sf::StackFrame)` must return a color. It can use any of the fields of the stackframe,
but `func`, `file`, `line`, and `from_c` might be common choices.

`colorbg` is the background color, and `colorfont` stores the choice of font color.

# Examples

```julia
using Plots, Profile, FlameGraphs
@profile plot(rand(5))    # "time to first plot"
g = flamegraph(C=true)
img = flamepixels(StackFrameCategory(), g)
```

Or you can tweak the coloration yourself:
```julia
function modcat(mod)
    mod == Plots && return colorant"purple"
    return nothing
end
img = flamepixels(StackFrameCategory(modcat), g)
```
"""
struct StackFrameCategory
    modcat   # categorization based on module (color if categorized, otherwise `nothing`)
    loccat   # categorization based on location
    colorbg::RGB{N0f8}
    colorfont::RGB{N0f8}
end

"""
    default_modcat(mod::Module)

Returns dark gray for `Core.Compiler`, light gray for `Core`, light blue for `Base`,
and otherwise returns `nothing`.
"""
function default_modcat(mod::Module)
    (mod === Core.Compiler || pm(mod) === Core.Compiler) && return colorant"gray60"
    (mod === Core || pm(mod) === Core) && return colorant"gray30"
    (mod === Base || pm(mod) === Base) && return colorant"lightblue"
    return nothing
end

"""
    default_loccat(sf::StackFrame)

Returns yellow for LLVM, orange for any other `ccall`, dark gray for anything in `./compiler`,
light blue for Base code, and red for anything else.
"""
function default_loccat(sf::StackFrame)
    file = String(sf.file)
    occursin("LLVM", file) && return colorant"yellow"
    sf.from_c && return colorant"orange"
    occursin(r"^\.[/\\]compiler[/\\]", file) && return colorant"gray60"
    occursin(r"^\.[/\\]", file) && return colorant"lightblue"
    return colorant"red"   # uncategorized
end

StackFrameCategory(modcat = default_modcat,
                   loccat = default_loccat) =
    StackFrameCategory(modcat, loccat, colorant"white", colorant"black")

function (sfc::StackFrameCategory)(s::Symbol)
    s === :bg && return sfc.colorbg
    s === :font && return sfc.colorfont
    throw(ArgumentError("unrecognized color id :$s"))
end

function (sfc::StackFrameCategory)(nextidx, j, nodedata)
    sf = nodedata.sf
    if isdefined(sf, :linfo)
        mi = sf.linfo
        if isa(mi, Core.MethodInstance)
            def = mi.def
            if isa(def, Module)
                mod = def
            else
                mod = def.module
            end
            col = sfc.modcat(mod)
            col !== nothing && return col
        end
    end
    return sfc.loccat(sf)
end

function pm(mod)
    pmod = parentmodule(mod)
    while mod !== pmod && mod !== Base && mod !== Core && mod !== Core.Compiler
        mod = pmod
        pmod = parentmodule(mod)
    end
    return mod
end

"""
    save(f::FileIO.File)
    save(f::FileIO.File, data, lidict)
    save(filename::AbstractString, data, ldict)

Save profiling data to a file. If `data` and `lidict` are not supplied, they are obtained
from

    data, lidict = Profile.retrieve()

Note that the data saved to the file discard some system-specific information to allow portability.
Some visualization modes, like [`StackFrameCategory`](@ref), are not available for data loaded from
such files.

These files conventionally have the extension ".jlprof".
If you just supply a string filename ending with this extension,
you must pass `data` and `lidict` explicitly, because
FileIO has its own interpretation of the meaning of `save` with no arguments.

# Example

For this to work, you need to `pkg> add FileIO FlameGraphs`.

```julia
julia> using Profile, FileIO    # you don't even need to explicitly use `FlameGraphs`

julia> @profile mapslices(sum, rand(3,3,3,3), dims=[1,2]);

julia> save("/tmp/myprof.jlprof", Profile.retrieve()...)
```
"""
function save(f::File{format"JLPROF"}, data::AbstractVector{<:Unsigned}, lidict::Profile.LineInfoDict)
    data_u64 = convert(AbstractVector{UInt64}, data)
    open(f, "w") do io
        write(io, magic(format"JLPROF"))
        # Write an endianness revealer
        write(io, 0x01020304)
        # Write an indicator that this is data/lidict format
        write(io, 0x01)
        write(io, Int64(length(data_u64)))
        write(io, data_u64)
        write(io, Int64(length(lidict)))
        for (k, v) in lidict
            write(io, k)
            write(io, Int32(length(v)))
            for sf in v
                sfwrite(io, sf)
            end
        end
    end
    return nothing
end

function save(f::File{format"JLPROF"}, g::Node{NodeData})
    queue = Union{Nothing,typeof(g)}[]
    open(f, "w") do io
        write(io, magic(format"JLPROF"))
        # Write an endianness revealer
        write(io, 0x01020304)
        # Write an indicator that this is node format
        write(io, 0x02)
        push!(queue, g)
        savedfs!(io, queue)
    end
    return nothing
end

function savedfs!(io, queue)
    isempty(queue) && return nothing
    node = pop!(queue)
    if node === nothing
        write(io, 0x00)    # leaf-terminator
    else
        write(io, 0xff)   # node
        data = node.data
        sfwrite(io, data.sf)
        write(io, data.status)
        write(io, data.span.start)
        write(io, data.span.stop)
        push!(queue, nothing)
        for child in reverse(collect(node))
            push!(queue, child)
        end
    end
    savedfs!(io, queue)
    return nothing
end

# Note: this doesn't work from FileIO because it returns an anonymous function for saving data
save(f::File{format"JLPROF"}) = save(f, Profile.retrieve()...)

"""
    data, lidict = load(f::FileIO.File)
    data, lidict = load(filename::AbstractString)
    g = load(...)

Load profiling data. You can reconstruct the flame graph from `flamegraph(data; lidict=lidict)`.
Some files may already store the data in graph format, and return a single argument `g`.
"""
function load(f::File{format"JLPROF"})
    open(f) do io
        skipmagic(io)
        load(io)
    end
end

function load(io::Stream{format"JLPROF"})
    endian = read(io, UInt32)
    endian == 0x01020304 || error("bswap not yet supported, please report as an issue to FlameGraphs.jl")
    fmt = read(io, UInt8)
    if fmt == 0x01
        # This is data/lidict format
        n = read(io, Int64)
        data = Vector{UInt64}(undef, n)
        read!(io, data)
        n = read(io, Int64)
        lidict = Profile.LineInfoDict()
        for i = 1:n
            k = read(io, UInt64)
            nsf = read(io, Int32)
            sfs = StackFrame[]
            for j = 1:nsf
                func    = symread(io)
                file    = symread(io)
                line    = read(io, Int)
                from_c  = read(io, Bool)
                inlined = read(io, Bool)
                push!(sfs, StackFrame(func, file, line, nothing, from_c, inlined, 0x0))
            end
            lidict[k] = sfs
        end
        return data, lidict
    end
    if fmt == 0x02
        tag = read(io, UInt8)
        tag == 0xff || error("first entry must be a node")
        sf = sfread(io)
        status = read(io, UInt8)
        start, stop = read(io, Int), read(io, Int)
        span = start:stop
        root = Node(NodeData(sf, status, span))
        loadbfs!(io, root)
        return root
    end
    error("format ", fmt, " not recognized")
end

function loadbfs!(io, parent)
    eof(io) && return nothing
    tag = read(io, UInt8)
    tag == 0x00 && return loadbfs!(io, parent.parent)
    tag == 0xff || error("expected leaf-terminator or node, got $tag")
    sf = sfread(io)
    status = read(io, UInt8)
    start, stop = read(io, Int), read(io, Int)
    span = start:stop
    child_data = NodeData(sf, status, span)
    child = addchild(parent, child_data)
    loadbfs!(io, child)
    return nothing
end

function sfwrite(io, sf::StackFrame)
    symwrite(io, sf.func)
    symwrite(io, sf.file)
    write(io, sf.line)
    write(io, sf.from_c)
    write(io, sf.inlined)
    return nothing
end

function sfread(io)
    func    = symread(io)
    file    = symread(io)
    line    = read(io, Int)
    from_c  = read(io, Bool)
    inlined = read(io, Bool)
    return StackFrame(func, file, line, nothing, from_c, inlined, 0x0)
end

function symwrite(io, sym::Symbol)
    str = string(sym)
    write(io, Int32(ncodeunits(str)))
    write(io, str)
    return nothing
end

function symread(io)
    n = read(io, Int32)
    b = read(io, n)
    return Symbol(String(b))
end

"""
    data = NodeData(sf::StackFrame, status::UInt8, span::UnitRange{Int})

Data associated with a single node in a flamegraph. `sf` is the stack frame
(see `?StackTraces.StackFrame`). `status` is a bitfield with information about this
node or any "suppressed" nodes immediately called by this one:

- `status & 0x01` is nonzero for runtime dispatch
- `status & 0x02` is nonzero for garbage collection

By default, C-language stackframes are omitted, but information about
their identity is accumulated into their caller's `status`.

`length(span)` is the number of times this stackframe was captured at this
depth and location in the flame graph. The starting index begins with the caller's
starting `span` but increments to ensure each child's `span` occupies a distinct
subset of the caller's `span`. Concretely, `span` is the range of indexes
that will be occupied by this stackframe when the flame graph is rendered.
"""
struct NodeData
    sf::StackFrame
    status::UInt8             # a bitfield, see below
    span::UnitRange{Int}
end

# status bitfield values
const runtime_dispatch = UInt8(1)
const gc_event         = UInt8(2)
const repl             = UInt8(4)

const defaultpruned = Tuple{Symbol,Symbol}[]

# This allows Revise to correct the location information in profiles
# ref https://github.com/JuliaLang/julia/pull/34235
lineinfodict(data::Vector{<:Unsigned}) = Profile.getdict(data)

"""
    lidict = lineinfodict(uips)

Look up location information for each instruction pointer in `uips`.
This is a `Dict(UInt64=>Vector{StackFrame})`, where the `UInt64` is the instruction pointer.
The reason a single instruction pointer gives a `Vector{StackFrame}` is because
of inlining; the first entry corresponds to the instruction that actually ran,
and the later entries correspond to the call chain.
"""
lineinfodict(s::Set) = lineinfodict(collect(s))

"""
    g = flamegraph(data=Profile.fetch(); lidict=nothing, C=false, combine=true, recur=:off, norepl=true, pruned=[], filter=nothing)

Compute a graph representing profiling data. To compute it for the currently-collected
profiling information, omit both `data` and `lidict`; if you are computing it for saved
profiling data, supply both. (`data` and `lidict` must be a matched pair from `Profile.retrieve()`.)

You can control the strategy with the following keywords:

- `C`: if `true`, include stackframes collected from `ccall`ed code.
- `recur`: represent recursive calls as if they corresponded to iteration.
- `norepl`: if true, the portions of stacktraces deeper than `REPL.eval_user_input` are discarded.
- `pruned`: a list of `(funcname, filename)` pairs that trigger the termination of this branch
  of the flame graph. You can use this to prevent very "tall" graphs from deeply-recursive
  calls, e.g., `pruned = [("sort!", "sort.jl")]` would omit nodes corresponding to Julia's
  `sort!` function and anything called by it. See also `recur` for an alternative strategy.
- `combine`: if true, instruction pointers that correspond to the same line of code are
  combined into a single stackframe
- `filter`: drop all branches that do not satisfy the filter condition. `Condition` can be `string`, `regex`
  or any function, that can be applied to `NodeData`. For example, `filter = "mapslices"` or equivalently
  `filter = x -> (x.sf.func == :mapslices)` removes all branches that do not contain `mapslices` Node as a child
  or ancestor.
- `threads::Union{Int,AbstractVector{Int},Nothing}`: specify which threads to include samples from. `nothing` returns all.
- `tasks::Union{Int,AbstractVector{Int},Nothing}`: specify which tasks to include samples from. `nothing` returns all.

`g` can be inspected using [`AbstractTrees.jl`'s](https://github.com/JuliaCollections/AbstractTrees.jl)
`print_tree`.
"""
function flamegraph(data=Profile.fetch(); lidict::Union{Dict{UInt64,Vector{Base.StackTraces.StackFrame}},Dict{UInt64,Base.StackTraces.StackFrame},Nothing}=nothing, C::Bool=false, combine::Bool=true,
        recur::Symbol=:off, norepl::Bool=true, pruned=defaultpruned, filter=nothing,
        threads::Union{Int,AbstractVector{Int},Nothing} = nothing,
        tasks::Union{UInt,AbstractVector{UInt},Nothing} = nothing)
    if lidict === nothing
        lidict = lineinfodict(unique(data))
    end
    data_u64 = convert(Vector{UInt64}, data)
    root = combine ? StackFrameTree{StackFrame}() : StackFrameTree{UInt64}()
    # Build the tree with C=true, regardless of user setting. This is because
    # we need the C frames to set the status flag. They will be omitted by `flamegraph!`
    # as needed.
    threads = something(threads, 1:Threads.nthreads())
    tasks = something(tasks, typemin(UInt):typemax(UInt))
    root, _ = Profile.tree!(root, data_u64, lidict, #= C =# true, recur, threads, tasks)
    if isempty(root.down)
        Profile.warning_empty()
        return nothing
    end
    root.count = sum(pr->pr.second.count, root.down)  # root count seems borked
    g = flamegraph!(Node(NodeData(root.frame, status(root, C), 1:root.count)), root; C=C, pruned=pruned)
    if norepl
        prunerepl!(g)
    end

    if filter != nothing
        filtergraph!(g, filter)
    end

    return g
end

function status(node, C::Bool)
    st = status(node.frame)
    C && return st
    # If we're suppressing C frames, check all C-frame children
    for child in values(node.down)
        child.frame.from_c || continue
        st |= status(child, C)
    end
    return st
end

function status(sf::StackFrame)
    st = UInt8(0)
    if sf.from_c && (sf.func === :jl_invoke || sf.func === :jl_apply_generic || sf.func === :ijl_apply_generic)
        st |= runtime_dispatch
    end
    if sf.from_c && startswith(String(sf.func), "jl_gc_")
        st |= gc_event
    end
    if !sf.from_c && sf.func === :eval_user_input && endswith(String(sf.file), "REPL.jl")
        st |= repl
    end
    return st
end

function nodematches(needle::Union{AbstractString,Regex,AbstractChar}, g::Node)
    return occursin(needle, string(g.data.sf))
end

function nodematches(needle::Function, g::Node)
    return needle(g.data)
end

function canfind(needle, g::Node, memo = Dict{Node, Bool}())
    haskey(memo, g) && return memo[g]
    if nodematches(needle, g)
        memo[g] = true
    else
        memo[g] = any(canfind(needle, child, memo) for child in g)
    end
    return memo[g]
end

function filtergraph!(g::Node, filter, memo = Dict{Node, Bool}())
    if !canfind(filter, g, memo)
        if isroot(g)
            @warn "The filter condition results in the root node pruning, so the filter is ignored"
        else
            prunebranch!(g)
        end
    else
        for child in g
            nodematches(filter, child) && continue
            filtergraph!(child, filter, memo)
        end
    end
end

function flamegraph!(graph, ptree; C=false, pruned=defaultpruned, hstart=first(graph.data.span))
    nexts = collect(values(ptree.down))
    lilist = collect(frame.frame for frame in nexts)
    p = Profile.liperm(lilist)
    for i in p
        down = nexts[i]
        frame, count = down.frame, down.count
        ispruned(frame, pruned) && continue
        if !C && frame.from_c
            flamegraph!(graph, down; C=C, pruned=pruned, hstart=hstart)
        else
            child = addchild(graph, NodeData(frame, status(down, C), hstart:hstart+count-1))
            flamegraph!(child, down; C=C, pruned=pruned)
        end
        hstart += count
    end
    return graph
end

function ispruned(frame, (fname, file)::Tuple{Any,Any})
    return frame.func == Symbol(fname) && frame.file == Symbol(file)
end

ispruned(frame, pruned) = any(t->ispruned(frame, t), pruned)

function prunerepl!(node)
    for c in node
        if c.data.status & repl != 0
            # Add children directly to the root node
            root = node
            replchild = c
            while !isroot(root)
                root = root.parent
                replchild = replchild.parent
            end
            graftchildren!(root, c)
            # Eliminate all nodes in between. This might include some that don't
            # call REPL code, but as this is also internal it seems OK.
            prunebranch!(replchild)
            return true
        else
            prunerepl!(c) && return true
        end
    end
    return false
end

module FlameGraphs

using Profile, LeftChildRightSiblingTrees
using Base.StackTraces: StackFrame
using Profile: StackFrameTree
using Colors, FixedPointNumbers, IndirectArrays
using FileIO

# AbstractTree interface for StackFrameTree:
using AbstractTrees
AbstractTrees.children(node::StackFrameTree) = node.down
AbstractTrees.printnode(io::IO, node::StackFrameTree) = print(io, node.frame)

export flamegraph, flamepixels, flametags, FlameColors, StackFrameCategory

include("graph.jl")
include("allocs.jl")
include("render.jl")
include("sfcategory.jl")
include("io.jl")

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    precompile(flametags, (Node{NodeData}, Matrix{RGB{N0f8}}))
    precompile(flamegraph, ())
    precompile(NodeData, (StackTraces.StackFrame, UInt8, UnitRange{Int64}))
    if isdefined(Base, :bodyfunction)
        m = which(flamegraph, (Vector{UInt64},))
        f = Base.bodyfunction(m)
        precompile(f, (Dict{UInt64,Vector{Base.StackTraces.StackFrame}}, Bool, Bool, Symbol, Bool, Vector{Tuple{Symbol,Symbol}}, Nothing, Nothing, Nothing, typeof(flamegraph), Vector{UInt64}))
        m = which(flamepixels, (FlameColors, Node))
        f = Base.bodyfunction(m)
        precompile(f, (Nothing, typeof(flamepixels), FlameColors, Node{NodeData}))
    end
end
_precompile_()

end # module

using FlameGraphs, AbstractTrees, Colors, FileIO
using Base.StackTraces: StackFrame
using Test, Profile, InteractiveUtils

# useful for testing
stackframe(func, file, line; C=false) = StackFrame(Symbol(func), Symbol(file), line, nothing, C, false, 0)

@testset "flamegraph" begin
    backtraces = UInt64[   4, 3, 2, 1,   # order: callees then caller
                        0, 6, 5, 1,
                        0, 8, 7,
                        0, 4, 3, 2, 1,
                        0]
    dummy_thread = 1
    dummy_task = UInt(0xf0f0f0f0)
    if isdefined(Profile, :add_fake_meta)
        backtraces = Profile.add_fake_meta(backtraces, threadid = dummy_thread, taskid = dummy_task)
    end
    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:f2, :file1, 5),
                                     3=>stackframe(:f3, :file2, 1),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))
    for threads in [nothing, dummy_thread], tasks in [nothing, dummy_task]
        @testset "Threads: $(repr(threads)), Tasks: $(repr(tasks))" begin
            g = flamegraph(backtraces; lidict=lidict, threads=threads, tasks=tasks)
            @test all(node->node.data.status == 0, PostOrderDFS(g))
            level1 = collect(g)
            @test length(level1) == 2
            n1, n2 = level1
            @test n1.data.sf.func === :f1
            @test n1.data.sf.line == 1
            @test n1.data.span == 1:3
            @test n2.data.sf.func === :f1
            @test n2.data.sf.line == 2
            @test n2.data.span == 4:4
            level2a = collect(n1)
            @test length(level2a) == 2
            n3, n4 = level2a
            @test n3.data.sf.func === :f2
            @test n3.data.sf.line == 5
            @test n3.data.span == 1:2
            @test n4.data.sf.func === :f4
            @test n4.data.sf.line == 20
            @test n4.data.span == 3:3
            level2b = collect(n2)
            @test length(level2b) == 1
            n5 = level2b[1]
            @test n5.data.sf.func === :f6
            @test n5.data.sf.line == 10
            @test n5.data.span == 4:4
            level3a = collect(n3)
            @test length(level3a) == 1
            n6 = level3a[1]
            @test n6.data.sf.func === :f3
            @test n6.data.sf.line == 1
            @test n6.data.span == 1:2
            level3b = collect(n4)
            @test length(level3b) == 1
            n7 = level3b[1]
            @test n7.data.sf.func === :f5
            @test n7.data.sf.line == 1
            @test n7.data.span == 3:3
            @test isempty(n5)
            level4a = collect(n6)
            @test length(level4a) == 1
            n8 = level4a[1]
            @test n8.data.sf.func === :f2
            @test n8.data.sf.line == 15
            @test n8.data.span == 1:2
            @test isempty(n7)
            @test isempty(n8)

            io = IOBuffer()
            print_tree(io, g)
            str = String(take!(io))
            @test str == """
NodeData(ip:0x0, 0x00, 1:4)
├─ NodeData(f1 at file1:1, 0x00, 1:3)
│  ├─ NodeData(f2 at file1:5, 0x00, 1:2)
│  │  └─ NodeData(f3 at file2:1, 0x00, 1:2)
│  │     └─ NodeData(f2 at file1:15, 0x00, 1:2)
│  └─ NodeData(f4 at file1:20, 0x00, 3:3)
│     └─ NodeData(f5 at file3:1, 0x00, 3:3)
└─ NodeData(f1 at file1:2, 0x00, 4:4)
   └─ NodeData(f6 at file3:10, 0x00, 4:4)
"""
        end
    end

    # pruning
    c = g.child.child
    @test c.child != c
    g = flamegraph(backtraces; lidict=lidict, pruned=[(:f3, "file2")])
    c = g.child.child
    @test c.child == c

    # Now make some of them C calls
    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:jl_f, :filec, 55; C=true),
                                     3=>stackframe(:jl_invoke, :file2, 1; C=true),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))
    g = flamegraph(backtraces; lidict=lidict)
    level1 = collect(g)
    @test length(level1) == 2
    n1, n2 = level1
    @test n1.data.sf.func === :f1
    @test n1.data.sf.line == 1
    @test n1.data.span == 1:3
    # Note: only span 2:3 contributes to the rt dispatch, but since we mark the caller
    # rather than the callee, and 1:3 all are the same caller, the whole thing gets marked.
    @test n1.data.status == FlameGraphs.runtime_dispatch
    @test n2.data.sf.func === :f1
    @test n2.data.sf.line == 2
    @test n2.data.span == 4:4
    @test n2.data.status == 0
    level2a = collect(n1)
    @test length(level2a) == 2
    n3, n4 = level2a
    @test n3.data.sf.func === :f4
    @test n3.data.sf.line == 20
    @test n3.data.span == 1:1
    @test n4.data.sf.func === :f2
    @test n4.data.sf.line == 15
    @test n4.data.span == 2:3
    level2b = collect(n2)
    @test length(level2b) == 1
    n5 = level2b[1]
    @test n5.data.sf.func === :f6
    @test n5.data.sf.line == 10
    @test n5.data.span == 4:4
    level3a = collect(n3)
    @test length(level3a) == 1
    n6 = level3a[1]
    @test n6.data.sf.func === :f5
    @test n6.data.sf.line == 1
    @test n6.data.span == 1:1
    @test isempty(n4)
    @test isempty(n5)
    @test isempty(n6)

    # Pruning REPL code
    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:eval_user_input, "REPL.jl", 5),
                                     3=>stackframe(:f3, :file2, 1),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))
    g = flamegraph(backtraces; lidict=lidict)
    sfc = [c.data.sf for c in g]
    @test lidict[3] ∈ sfc
    @test lidict[1] ∉ sfc
end

@testset "flamegraph string filtering" begin
    backtraces = UInt64[   4, 3, 2, 1,   # order: callees then caller
                        0, 6, 5, 1,
                        0, 8, 7,
                        0, 4, 3, 2, 1,
                        0]
    if isdefined(Profile, :add_fake_meta)
        backtraces = Profile.add_fake_meta(backtraces)
    end
    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:f2, :file1, 5),
                                     3=>stackframe(:f3, :file2, 1),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))
    g = flamegraph(backtraces; lidict=lidict, filter = "f2")
    level1 = collect(g)
    @test length(level1) == 1
    n1 = level1[1]
    @test n1.data.sf.func == :f1
    @test n1.data.sf.line == 1
    @test n1.data.span == 1:3
    level2 = collect(n1)
    @test length(level2) == 1
    n2 = level2[1]
    @test n2.data.sf.func == :f2
    @test n2.data.sf.line == 5
    @test n2.data.span == 1:2
    level3 = collect(n2)
    @test length(level3) == 1
    n3 = level3[1]
    @test n3.data.sf.func == :f3
    @test n3.data.sf.line == 1
    @test n3.data.span == 1:2
    level4 = collect(n3)
    @test length(level4) == 1
    n4 = level4[1]
    @test n4.data.sf.func == :f2
    @test n4.data.sf.line == 15
    @test n4.data.span == 1:2
    @test isempty(collect(n4))
end

@testset "flamegraph function filtering" begin
    backtraces = UInt64[   4, 3, 2, 1,   # order: callees then caller
                        0, 6, 5, 1,
                        0, 8, 7,
                        0, 4, 3, 2, 1,
                        0]
    if isdefined(Profile, :add_fake_meta)
        backtraces = Profile.add_fake_meta(backtraces)
    end
    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:f2, :file1, 5),
                                     3=>stackframe(:f3, :file2, 1),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))

    g = flamegraph(backtraces; lidict=lidict, filter = x -> (x.sf.func == :f1) & (x.sf.line == 1))
    level1 = collect(g)
    @test length(level1) == 1
    n1 = level1[1]
    @test n1.data.sf.func == :f1
    @test n1.data.sf.line == 1
    @test n1.data.span == 1:3
    level2 = collect(n1)
    @test length(level2) == 2
    n2, n2b = level2
    @test n2.data.sf.func == :f2
    @test n2.data.sf.line == 5
    @test n2.data.span == 1:2
    @test n2b.data.sf.func == :f4
    @test n2b.data.sf.line == 20
    @test n2b.data.span == 3:3

    level3 = collect(n2)
    @test length(level3) == 1
    n3 = level3[1]
    @test n3.data.sf.func == :f3
    @test n3.data.sf.line == 1
    @test n3.data.span == 1:2
    level3b = collect(n2b)
    @test length(level3b) == 1
    n3b = level3b[1]
    @test n3b.data.sf.func == :f5
    @test n3b.data.sf.line == 1
    @test n3b.data.span == 3:3
    @test isempty(collect(n3b))

    level4 = collect(n3)
    @test length(level4) == 1
    n4 = level4[1]
    @test n4.data.sf.func == :f2
    @test n4.data.sf.line == 15
    @test n4.data.span == 1:2
    @test isempty(collect(n4))
end

@testset "flamegraph wrong filtering is ignored" begin
    backtraces = UInt64[   4, 3, 2, 1,   # order: callees then caller
                        0, 6, 5, 1,
                        0, 8, 7,
                        0, 4, 3, 2, 1,
                        0]
    if isdefined(Profile, :add_fake_meta)
        backtraces = Profile.add_fake_meta(backtraces)
    end

    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:f2, :file1, 5),
                                     3=>stackframe(:f3, :file2, 1),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))

    g = (@test_logs (:warn, "The filter condition results in the root node pruning, so the filter is ignored") flamegraph(backtraces; lidict=lidict, filter = "f7"))
    @test all(node->node.data.status == 0, PostOrderDFS(g))
    level1 = collect(g)
    @test length(level1) == 2
    n1, n2 = level1
    @test n1.data.sf.func === :f1
    @test n1.data.sf.line == 1
    @test n1.data.span == 1:3
    @test n2.data.sf.func === :f1
    @test n2.data.sf.line == 2
    @test n2.data.span == 4:4
    level2a = collect(n1)
    @test length(level2a) == 2
    n3, n4 = level2a
    @test n3.data.sf.func === :f2
    @test n3.data.sf.line == 5
    @test n3.data.span == 1:2
    @test n4.data.sf.func === :f4
    @test n4.data.sf.line == 20
    @test n4.data.span == 3:3
    level2b = collect(n2)
    @test length(level2b) == 1
    n5 = level2b[1]
    @test n5.data.sf.func === :f6
    @test n5.data.sf.line == 10
    @test n5.data.span == 4:4
    level3a = collect(n3)
    @test length(level3a) == 1
    n6 = level3a[1]
    @test n6.data.sf.func === :f3
    @test n6.data.sf.line == 1
    @test n6.data.span == 1:2
    level3b = collect(n4)
    @test length(level3b) == 1
    n7 = level3b[1]
    @test n7.data.sf.func === :f5
    @test n7.data.sf.line == 1
    @test n7.data.span == 3:3
    @test isempty(n5)
    level4a = collect(n6)
    @test length(level4a) == 1
    n8 = level4a[1]
    @test n8.data.sf.func === :f2
    @test n8.data.sf.line == 15
    @test n8.data.span == 1:2
    @test isempty(n7)
    @test isempty(n8)
end

@testset "flamepixels" begin
    backtraces = UInt64[   4, 3, 2, 1,   # order: callees then caller
                        0, 6, 5, 1,
                        0, 8, 7,
                        0, 4, 3, 2, 1,
                        0]
    if isdefined(Profile, :add_fake_meta)
        backtraces = Profile.add_fake_meta(backtraces)
    end
    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:f2, :file1, 5),
                                     3=>stackframe(:f3, :file2, 1),
                                     4=>stackframe(:f2, :file1, 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:f5, :file3, 1),
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:f6, :file3, 10))
    g = flamegraph(backtraces; lidict=lidict)
    img = flamepixels(g)
    fc = FlameColors()
    @test fc(:bg) === fc.colorbg
    @test_throws ArgumentError fc(:unknown)

    @test all(img[:,1] .== fc.colors[1])
    @test all(img[1:3,2] .== fc.colors[3])
    @test img[4,2] == fc.colors[4]
    @test all(img[1:2,3] .== fc.colors[1])
    @test img[3,3] == fc.colors[2]
    @test img[4,3] == fc.colors[1]
    @test all(img[1:2,4] .== fc.colors[3])
    @test img[3,4] == fc.colors[4]
    @test img[4,4] == fc.colorbg
    @test all(img[1:2,5] .== fc.colors[1])
    @test all(img[3:4,5] .== fc.colorbg)
    imgtags = flametags(g, img)
    @test axes(imgtags) == axes(img)
    @test imgtags[1,2] == lidict[1]
    @test imgtags[4,2] == lidict[7]
    @test imgtags[4,end] == StackTraces.UNKNOWN

    lidict = Dict{UInt64,StackFrame}(1=>stackframe(:f1, :file1, 1),
                                     2=>stackframe(:jl_f, :filec, 55; C=true),
                                     3=>stackframe(:jl_invoke, :file2, 1; C=true),
                                     4=>stackframe(:_ZL, Symbol("libLLVM-8.0.so"), 15),
                                     5=>stackframe(:f4, :file1, 20),
                                     6=>stackframe(:copy, Symbol(".\\expr.jl"), 1), # on Windows
                                     7=>stackframe(:f1, :file1, 2),
                                     8=>stackframe(:typeinf, Symbol("./compiler/typeinfer.jl"), 10))
    g = flamegraph(backtraces; lidict=lidict)
    img = flamepixels(g)
    @test all(img[:,1] .== fc.colors[1])
    # Note: only span 2:3 contributes to the rt dispatch, but since we mark the caller
    # rather than the callee, and 1:3 all are the same caller, the whole thing gets marked.
    @test all(img[1:3,2] .== fc.colorsrt[3])
    @test img[4,2] == fc.colors[4]
    @test img[1,3] == fc.colors[1]
    @test all(img[2:3,3] .== fc.colors[2])
    @test img[4,3] == fc.colors[1]
    @test img[1,4] == fc.colors[3]
    @test all(img[2:4,4] .== fc.colorbg)

    # Customizing FlameColors
    # the classic colors which were used in FlameGraphs v0.1 or ProfileView v0.5
    fc2 = FlameColors(
        parse.(RGB, ["#E870DD", "#32B44E", "#1AA2FF", "#00DEE6", "#FFA49C",
                     "#9E9E9E", "#A8A200", "#CDB9FF", "#00E5B2", "#FF5F82"]),
        colorant"white", colorant"black", [colorant"red"], [colorant"orange"])
    img = flamepixels(fc2, g)
    @test all(img[:,1] .== fc2.colors[1])
    @test all(img[1:3,2] .== fc2.colorsrt[1])
    @test img[4,2] == fc2.colors[7]
    @test img[1,3] == fc2.colors[1]
    @test all(img[2:3,3] .== fc2.colors[2])
    @test img[4,3] == fc2.colors[3]
    @test img[1,4] == fc2.colors[6]
    @test all(img[2:4,4] .== fc2.colorbg)

    # dark mode
    fc3 = FlameColors(; darkmode = true)

    sfc = StackFrameCategory()
    @test sfc(:bg) == sfc.colorbg
    @test_throws ArgumentError sfc(:unknown)

    img = flamepixels(sfc, g)
    @test all(img[:,1] .== colorant"orange")
    @test all(img[1:3,2] .== colorant"red")
    @test img[4,2] == colorant"red"
    @test img[1,3] == colorant"red"
    @test all(img[2:3,3] .== colorant"yellow")
    @test img[4,3] == colorant"gray60"
    @test img[1,4] == colorant"lightblue"
    @test all(img[2:4,4] .== colorant"white")
end

@testset "Profiling" begin
    A = randn(100, 100, 200)
    Profile.clear()
    mapslices(sum, A; dims=2)  # compile it so we don't end up profiling inference
    g = nothing
    for _ in 1:10
        @profile mapslices(sum, A; dims=2)
        g = flamegraph()
        (g !== nothing && FlameGraphs.depth(g) > 10) && break
    end
    @test FlameGraphs.depth(g) > 10
    img = flamepixels(StackFrameCategory(), flamegraph(C=true))
    @test any(img .== colorant"orange")
    A = [1,2,3]
    sum(A)
    Profile.clear()
    @profile sum(A)
    Sys.islinux() && @test_logs (:warn, r"There were no samples collected.") flamegraph() === nothing
end

@testset "Runtime dipatch detection" begin
    # Test is from SnoopCompile
    mappushes!(f, dest, src) = (for item in src push!(dest, f(item)) end; return dest)
    function spell_spec(::Type{T}) where T
        name = Base.unwrap_unionall(T).name.name
        str = ""
        for c in string(name)
            str *= c
        end
        return str
    end
    Ts = subtypes(Any)[1:20]   # we don't need all of them
    mappushes!(spell_spec, [], Ts)
    rtds = []
    for _ in 1:10 # try to get a runtime dispatch on unfortunately flaky profiling
        @profile for i = 1:10000
            mappushes!(spell_spec, [], Ts)
        end
        _, sfdict = Profile.retrieve()
        for sfs in values(sfdict)
            for sf in sfs
                if (FlameGraphs.status(sf) & FlameGraphs.runtime_dispatch) != 0
                    push!(rtds, sfs)
                    break
                end
            end
        end
        isempty(rtds) || break
    end
    @test !isempty(rtds)
end

@testset "IO" begin
    function nodeeq(a::FlameGraphs.Node, b::FlameGraphs.Node)
        nodeeq(a.data, b.data) || return false
        reta, retb = iterate(a), iterate(b)
        while true
            reta === retb === nothing && return true
            (reta === nothing) || (retb === nothing) && return false
            childa, statea = reta
            childb, stateb = retb
            nodeeq(childa, childb) || return false
            reta, retb = iterate(a, statea), iterate(b, stateb)
        end
    end
    nodeeq(a::FlameGraphs.NodeData, b::FlameGraphs.NodeData) =
        nodeeq(a.sf, b.sf) &&
        a.status == b.status &&
        a.span == b.span
    nodeeq(a::Base.StackFrame, b::Base.StackFrame) =
        a.func == b.func &&
        a.file == b.file &&
        a.line == b.line &&
        a.from_c == b.from_c &&
        a.inlined == b.inlined

    A = randn(100, 100, 200)
    Profile.clear()
    while Profile.len_data() == 0
        @profile mapslices(sum, A; dims=2)
    end
    fn = tempname()*".jlprof"
    f = File{format"JLPROF"}(fn)
    FlameGraphs.save(f)
    data, lidict = FlameGraphs.load(f)
    datar, lidictr = Profile.retrieve()
    @test data == datar
    @test lidictr == lidict
    rm(fn)
    fn = tempname()*".jlprof"
    f = File{format"JLPROF"}(fn)
    g = flamegraph(data; lidict=lidict)
    FlameGraphs.save(f, g)
    gr = FlameGraphs.load(f)
    @test nodeeq(g, gr)
    rm(fn)
end

# Issues #52 and #70
@testset "allocation profiler" begin
    # Each child's span must immediately follow its previous sibling, starting
    # at the parent's span; children may sum to less than the parent (self-weight).
    function spansvalid(node)
        kids = collect(node)
        isempty(kids) && return true
        s = first(node.data.span)
        for k in kids
            first(k.data.span) == s || return false
            spansvalid(k) || return false
            s = last(k.data.span) + 1
        end
        return last(kids).data.span[end] <= last(node.data.span)
    end

    alloc_workload() = [Vector{Float64}(undef, 4) for _ in 1:2000]

    alloc_workload()  # compile
    Profile.Allocs.clear()
    Profile.Allocs.@profile sample_rate=1.0 alloc_workload()
    results = Profile.Allocs.fetch()

    g = flamegraph(results)
    @test g !== nothing
    @test first(g.data.span) == 1
    @test length(g.data.span) == sum(a.size for a in results.allocs)
    @test spansvalid(g)

    # The leaf of every branch names the allocated type, with no location info.
    leaves = [n for n in PostOrderDFS(g) if isempty(collect(n))]
    @test !isempty(leaves)
    @test all(l -> l.data.sf.file === Symbol("") && l.data.sf.line == 0, leaves)
    @test any(l -> l.data.sf.func === Symbol("Vector{Float64}"), leaves)
    @test any(n -> n.data.sf.func === :alloc_workload, PreOrderDFS(g))

    # `mode=:count` weights each node by the number of allocations.
    gc = flamegraph(results; mode=:count)
    @test length(gc.data.span) == length(results.allocs)
    @test spansvalid(gc)

    # Suppressed C frames still account for all the allocated bytes.
    gC = flamegraph(results; C=true)
    @test length(gC.data.span) == length(g.data.span)
    @test spansvalid(gC)

    @test_throws "`mode` must be `:bytes` or `:count`" flamegraph(results; mode=:nope)

    # Pathologically long type names are truncated so leaf labels stay readable.
    bigtype = NamedTuple{ntuple(i -> Symbol(:field, i), 40), NTuple{40,Float64}}
    @test length(string(bigtype)) > 200
    short = FlameGraphs.alloctypename(bigtype)
    @test length(short) <= 120
    @test occursin('…', short)
    @test FlameGraphs.alloctypename(Vector{Float64}) == "Vector{Float64}"

    empty = Profile.Allocs.AllocResults(Profile.Allocs.Alloc[])
    @test (@test_logs (:warn, r"There were no samples collected") flamegraph(empty)) === nothing
end

struct FlameColors
    colors::Vector{RGB{N0f8}}
    colorbg::RGB{N0f8}
    colorfont::RGB{N0f8}
    colorsrt::Vector{RGB{N0f8}}
    colorsgc::Vector{RGB{N0f8}}
end

"""
    fcolor = FlameColors(n::Integer=2;
                         colorbg=colorant"white", colorfont=colorant"black",
                         colorsrt=colorant"crimson", colorsgc=colorant"orange")

Choose a set of colors for rendering a flame graph. There are several special colors:

- `colorbg` is the background color
- `colorfont` is used when annotating stackframes with text
- `colorsrt` highlights [runtime dispatch](https://discourse.julialang.org/t/dynamic-dispatch/6963), typically a costly process
- `colorsgc` highlights garbage-collection events

`n` specifies the number of "other" colors to choose when one of the above is not relevant.
`FlameColors` chooses `2n` colors: the first `n` colors for odd depths in the stacktrace and
the last `n` colors for even depths in the stacktrace. Consequently, different stackframes will typically
be distinguishable from one another by color.

The highlighting can be disabled by passing `nothing` or a zero-element vector
for `colorsrt` or `colorsgc`. When a single color is passed for `colorsrt` or
`colorsgc`, this method generates four variant colors slightly different from
the specified color. `colorsrt` or `colorsgc` can also be specified as multiple
colors with a vector. The first half of the vector is for odd depths and the
second half is for even depths. By using a one-element vector instead of a
single color, the specified color is always used.

While the return value is a `struct`, it is callable and can be used as the
`fcolor` input for `flamepixels`.
"""
function FlameColors(n::Integer=2; darkmode = false,
                     colorbg=(darkmode ? RGB(0.09,0.09,0.09) : colorant"white"),
                     colorfont=(darkmode ? colorant"white" : colorant"black"),
                     colorsrt=colorant"crimson", colorsgc=colorant"orange")
    seeds = [colorbg, colorfont]
    function make_variations(color)
        color === nothing && return RGB{N0f8}[]
        isa(color, AbstractVector) && return color
        c = convert(LCHab, color)
        a = LCHab(min(c.l+2.5, 100.0), c.c+10.0, c.h-7.5)
        b = LCHab(max(c.l-2.5, 0.0), max(c.c-10.0, 0.0), c.h+7.5)
        RGB{N0f8}.(range(a, stop=b, length=4))
    end
    colorsrt = make_variations(colorsrt)
    colorsgc = make_variations(colorsgc)
    append!(seeds, colorsrt)
    append!(seeds, colorsgc)
    darkmode && append!(seeds, make_variations(RGB(0.9,0.9,0.9))) # bias away from white
    nseeds = length(seeds)
    colors = distinguishable_colors(2n+nseeds, seeds,
                                    transform=c->deuteranopic(c, 0.95),
                                    lchoices=Float64[65, 80],
                                    cchoices=Float64[10, 55],
                                    hchoices=range(10, stop=350, length=18))[nseeds+1:end]
    sort!(colors, by=c->colordiff(c, darkmode ? colorfont : colorbg))
    return FlameGraphs.FlameColors(colors, colorbg, colorfont, colorsrt, colorsgc)
end

const default_colors = FlameColors()
const default_colors_dark = FlameColors(; darkmode = true)

function (colors::FlameColors)(s::Symbol)
    s === :bg && return colors.colorbg
    s === :font && return colors.colorfont
    throw(ArgumentError("unrecognized color id :$s"))
end

function (colors::FlameColors)(nextidx, j::Integer, data)
    idx = nextidx[j]
    nextidx[j] = idx + 1
    if length(colors.colorsrt) > 0 && (data.status & runtime_dispatch) != 0
        colorvec = colors.colorsrt
    elseif length(colors.colorsgc) > 0 && (data.status & gc_event) != 0
        colorvec = colors.colorsgc
    else
        colorvec = colors.colors
    end
    n = length(colorvec)
    m = (n + 1)÷2
    return colorvec[mod1(mod1(idx, m) + iseven(j) * m, n)]
end

"""
    img = flamepixels(g; kwargs...)

Return a flamegraph as a matrix of RGB colors. The first dimension corresponds to cost,
the second dimension to depth in the call stack.

See also [`flametags`](@ref).
"""
flamepixels(g::Node; kwargs...) = flamepixels(default_colors, g; kwargs...)

"""
    img = flamepixels(fcolor, g; costscale=nothing)

Return a flamegraph as a matrix of RGB colors, customizing the color choices.

## fcolor

`fcolor` is a function that returns the
color used for the current item in the call stack.
See [`FlameColors`](@ref) for the default implementation of `fcolor`.

If you provide a custom `fcolor`, it must support the following API:

    colorbg = fcolor(:bg)
    colorfont = fcolor(:font)

must return the background and font colors.

    colornode = fcolor(nextidx::Vector{Int}, j, data::NodeData)

chooses the color for the node represented by `data` (see [`NodeData`](@ref)).
`j` corresponds to depth in the call stack and `nextidx[j]` holds the state for the next
color choice.
In general, if you have a list of colors, `fcolor` should cycle `nextidx[j]` to ensure that
the next call to `fcolor` with this `j` moves on to the next color.
(However, you may not want to increment `nextidx[j]` if you are choosing the color by some
means other than cycling through a list.)

By accessing `data.sf`, you can choose to color individual nodes based on the identity of
the stackframe.

## costscale

`costscale` can be used to limit the size of `img` when profiling collected a large number of stacktraces.
The size of the first dimension of `img` is proportional to the total number of
stacktraces collected during profiling. `costscale` is the constant of proportionality;
for example, setting `costscale=0.2` would mean that `size(img, 1)` would be approximately
1/5 the number of stacktraces collected by the profiler. The default value of `nothing`
imposes an upper bound of approximately 1000 pixels along the first dimension, with
`costscale=1` chosen if the number of samples is less than 1000.
"""
function flamepixels(fcolor, g::Node; costscale=nothing)
    ndata = g.data
    w = length(ndata.span)
    if costscale === nothing
        costscale = w < 10^3 ? 1.0 : 10^3/w
    end
    h = depth(g)
    img = fill(fcolor(:bg), round(Int, w*costscale), h)
    nextidx = fill(1, h)
    img[scale(ndata.span, costscale), 1] .= fcolor(nextidx, 1, ndata)
    return flamepixels!(fcolor, img, g, 2, nextidx, costscale)
end

function flamepixels!(fcolor, img, g, j, nextidx, costscale)
    for c in g
        ndata = c.data
        img[scale(ndata.span, costscale), j] .= fcolor(nextidx, j, ndata)
        flamepixels!(fcolor, img, c, j+1, nextidx, costscale)
    end
    return img
end

"""
    tagimg = flametags(g, img)

From a flame graph `g`, generate an array `tagimg` with the same axes as `img`,
encoding the stackframe represented by each pixel of `img`.

See [`flamepixels`](@ref) to generate `img`.
"""
function flametags(g, img)
    tags = fill(1, axes(img))
    ndata = g.data
    sflist = StackFrame[StackTraces.UNKNOWN]
    # use an IdDict so that equal stackframes from different places in the flamegraph can be
    # distinguishable via egality
    sf2tag = IdDict{StackFrame,Int}(StackTraces.UNKNOWN=>1)
    tags[:,1] .= tagidx(ndata.sf, sf2tag, sflist)
    costscale = size(img, 1) / length(ndata.span)
    flametags!(tags, g, sf2tag, sflist, 2, costscale)
    return IndirectArray(tags, sflist)
end

function flametags!(tags, parent, sf2tag, sflist, level, costscale)
    for c in parent
        ndata = c.data
        tags[scale(ndata.span, costscale), level] .= tagidx(ndata.sf, sf2tag, sflist)
        flametags!(tags, c, sf2tag, sflist, level+1, costscale)
    end
end

scale(rng::UnitRange, costscale) = max(1, round(Int, costscale*first(rng))):round(Int, costscale*last(rng))

function tagidx(sf, sf2tag, sflist)
    idx = get(sf2tag, sf, length(sflist)+1)
    if idx > length(sflist)
        sf2tag[sf] = idx
        push!(sflist, sf)
    end
    return idx
end

# Support for Julia's allocation profiler, `Profile.Allocs`.
# Implements issues #52 and #70. The allocation profiler hands back already-decoded
# stack traces (rather than instruction pointers), so the tree is built directly
# instead of going through `Profile.tree!`.

# An intermediate tree used while accumulating allocation weights. Identical
# stackframes are merged, keyed by `framekey`.
const AllocKey = Tuple{Symbol,Symbol,Int,Bool}

mutable struct AllocTreeNode
    const sf::StackFrame
    status::UInt8
    weight::Int
    const children::Dict{AllocKey,AllocTreeNode}
end
AllocTreeNode(sf::StackFrame) = AllocTreeNode(sf, UInt8(0), 0, Dict{AllocKey,AllocTreeNode}())

framekey(sf::StackFrame) = (sf.func, sf.file, sf.line, sf.from_c)

# The leaf of each allocation branch names the type of the allocated object.
# `Profile.Allocs` reports unknown types as `Profile.Allocs.UnknownType`; strip
# the module qualifier so the leaf reads simply as `UnknownType`. Type names can
# occasionally be enormous (deeply parametric types, large `NamedTuple`s); keep
# the label bounded, retaining head and tail, so it stays readable in
# `print_tree` and other renderers.
const alloctypename_maxlen = 120

function alloctypename(@nospecialize(T))
    name = replace(string(T), "Profile.Allocs." => "")
    if length(name) > alloctypename_maxlen
        head = alloctypename_maxlen ÷ 2 - 1
        tail = alloctypename_maxlen - head - 1
        name = string(first(name, head), '…', last(name, tail))
    end
    return name
end

"""
    g = flamegraph(allocs::Profile.Allocs.AllocResults; C=false, mode=:bytes, pruned=[], norepl=true, filter=nothing)

Compute a flame graph from data collected by Julia's allocation profiler,
`Profile.Allocs`. Collect the data with `Profile.Allocs.@profile`, then pass the
result of `Profile.Allocs.fetch()`:

```julia
Profile.Allocs.@profile my_computation()
g = flamegraph(Profile.Allocs.fetch())
```

The width of each node measures memory allocation. With `mode=:bytes` (the
default) widths are the number of bytes allocated; with `mode=:count` they are
the number of allocations. The leaf of each branch names the type of the
allocated object.

The keywords `C`, `pruned`, `norepl`, and `filter` behave as in the
time-profiling [`flamegraph`](@ref) method.
"""
function flamegraph(allocs::Profile.Allocs.AllocResults; C::Bool=false, mode::Symbol=:bytes,
        pruned=defaultpruned, norepl::Bool=true, filter=nothing)
    weightfun = if mode === :bytes
        alloc -> Int(alloc.size)
    elseif mode === :count
        alloc -> 1
    else
        error("`mode` must be `:bytes` or `:count`, got ", repr(mode))
    end

    root = AllocTreeNode(StackFrame(Symbol("root"), Symbol(""), 0))
    for alloc in allocs.allocs
        w = weightfun(alloc)
        root.weight += w
        node = root
        pruned_here = false
        # `stacktrace` runs leaf-to-root; reverse it so we descend from the root.
        for sf in Iterators.reverse(alloc.stacktrace)
            if !C && sf.from_c
                # Suppressed C frames still contribute their status to the caller.
                node.status |= status(sf)
                continue
            end
            if ispruned(sf, pruned)
                pruned_here = true
                break
            end
            child = get!(() -> AllocTreeNode(sf), node.children, framekey(sf))
            child.status |= status(sf)
            child.weight += w
            node = child
        end
        pruned_here && continue
        tname = alloctypename(alloc.type)
        leaf = get!(() -> AllocTreeNode(StackFrame(Symbol(tname), Symbol(""), 0)),
                    node.children, (Symbol(tname), Symbol(""), 0, false))
        leaf.weight += w
    end

    if root.weight == 0
        Profile.warning_empty()
        return nothing
    end

    g = Node(NodeData(root.sf, root.status, 1:root.weight))
    flamegraph_allocs!(g, root)
    norepl && prunerepl!(g)
    filter !== nothing && filtergraph!(g, filter)
    return g
end

function flamegraph_allocs!(graph, atn::AllocTreeNode)
    childnodes = collect(values(atn.children))
    isempty(childnodes) && return graph
    # Order siblings as the time-profiling flamegraph does, by location info.
    p = Profile.liperm(StackFrame[c.sf for c in childnodes])
    hstart = first(graph.data.span)
    for i in p
        child = childnodes[i]
        cnode = addchild(graph, NodeData(child.sf, child.status, hstart:hstart+child.weight-1))
        flamegraph_allocs!(cnode, child)
        hstart += child.weight
    end
    return graph
end

# FlameGraphs.jl

FlameGraphs is a package that adds functionality to Julia's `Profile` standard library. It is directed at the algorithmic side of producing [flame graphs](http://www.brendangregg.com/flamegraphs.html), but includes some "format agnostic" rendering code.
FlameGraphs is used by IDEs like [Juno](https://github.com/JunoLab/Juno.jl) and visualization packages like [ProfileView](https://github.com/timholy/ProfileView.jl), [ProfileVega](https://github.com/davidanthoff/ProfileVega.jl), and
[ProfileSVG](https://github.com/timholy/ProfileSVG.jl).

## Computing a flame graph

The core function of FlameGraphs is to compute a tree representation of a set of backtraces collected by Julia's [sampling profiler](https://docs.julialang.org/en/latest/manual/profile/). For a demonstration we'll use the following function:

```@repl profile_test
function profile_test(n)
    for i = 1:n
        A = randn(100,100,20)
        m = maximum(A)
        Am = mapslices(sum, A; dims=2)
        B = A[:,:,5]
        Bsort = mapslices(sort, B; dims=1)
        b = rand(100)
        C = B.*b
    end
end

profile_test(1)              # run once to compile

using Profile, FlameGraphs

Profile.clear(); @profile profile_test(10)    # collect profiling data

g = flamegraph()
```

This may not be very informative on its own; the only thing it communicates clearly is the number of samples (separate backtraces) collected during profiling, given by the range in the printed `NodeData`.
(If you run this example yourself, you might get a different number of samples depending on how fast your machine is and which operating system you use.)
It becomes more meaningful with

```@repl profile_test
using AbstractTrees

print_tree(g)
```

Each node of the tree consists of a `StackFrame` indicating the file, function, and line number of a particular entry in one or more backtraces, a status flag, and a range that corresponds to the horizontal span of a particular node when the graph is rendered.  See [`FlameGraphs.NodeData`](@ref) for more information.
(For developers, `g` is a
[left-child, right-sibling tree](https://github.com/JuliaCollections/LeftChildRightSiblingTrees.jl).)

[`flamegraph`](@ref) has several options that can be used to control how it computes the graph.

## Allocation profiles

FlameGraphs can also represent data collected by Julia's [allocation profiler](https://docs.julialang.org/en/v1/stdlib/Profile/#Profile.Allocs.@profile) (`Profile.Allocs`). Collect the data and pass the result of `Profile.Allocs.fetch()` to `flamegraph`:

```julia
using Profile, FlameGraphs

Profile.Allocs.@profile profile_test(10)

g = flamegraph(Profile.Allocs.fetch())
```

For an allocation flame graph, the width of each node measures memory allocation rather than run time: by default the number of bytes allocated, or the number of separate allocations with `mode=:count`. The leaf of each branch names the type of the allocated object. The resulting `g` is an ordinary flame graph and can be rendered exactly like a time profile.

## Rendering a flame graph

You can create a "bitmap" representation of the flame graph with [`flamepixels`](@ref):

```julia
julia> img = flamepixels(g)
125×20 Array{RGB{N0f8},2} with eltype ColorTypes.RGB{FixedPointNumbers.Normed{UInt8,8}}:
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)      …  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)   …  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)      RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 ⋮                                                   ⋱                                                                        
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.62,0.62,0.62)   …  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)         RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)         RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)         RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)         RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.659,0.635,0.0)  …  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)         RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(1.0,1.0,1.0)         RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.804,0.725,1.0)     RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
 RGB{N0f8}(1.0,0.0,0.0)  RGB{N0f8}(0.804,0.725,1.0)     RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)  RGB{N0f8}(1.0,1.0,1.0)
```

You can display this in an image viewer, but for interactive exploration `ProfileView.jl` adds additional features.

The coloration scheme can be customized as described in the documentation for [`flamepixels`](@ref), with the default coloration provided by [`FlameColors`](@ref).
This default uses cycling colors to distinguish different stack frames, while coloring runtime dispatch red and garbage-collection orange.
If we profile "time to first plot,"

```
using Plots, Profile, FlameGraphs
@profile plot(rand(5))    # "time to first plot"
g = flamegraph(C=true)
```
```@setup ttfp
using FileIO, FlameGraphs, Colors, Profile

function profile_test(n)
    for i = 1:n
        A = randn(100,100,20)
        m = maximum(A)
        Am = mapslices(sum, A; dims=2)
        B = A[:,:,5]
        Bsort = mapslices(sort, B; dims=1)
        b = rand(100)
        C = B.*b
    end
end
profile_test(1)
Profile.clear()
@profile profile_test(10)
g = flamegraph(C=true)
save_image(name, img) = save(joinpath("assets", name), reverse(img'; dims=1))
```
```@repl ttfp
img = flamepixels(g);
save_image("ttfp.png", img) # hide
```
we might get something like this:

![default_colors](assets/ttfp.png)

The following is an example of a customized coloration:
```@repl ttfp
fcolor = FlameColors(colorbg=colorant"#444", colorfont=colorant"azure",
                     colorsrt=colorant"lavender", colorsgc=nothing);
img = flamepixels(fcolor, g);
save_image("customized_ttfp.png", img) # hide
```
![customized_colors](assets/customized_ttfp.png)

An alternative is to color frames by their category:

```@repl ttfp
img = flamepixels(StackFrameCategory(), g);
```
in which case we might get something like this:

![sfc_colors](assets/categorize_ttfp.png)

In this plot, dark gray indicates time spent in `Core.Compiler` (mostly inference), yellow in [LLVM](https://en.wikipedia.org/wiki/LLVM), orange other `ccall`s, light blue in `Base`,
and red is uncategorized (mostly package code).

[`StackFrameCategory`](@ref) allows you to customize these choices and recognize arbitrary modules.

# Reference

## Computing flame graphs

```@docs
flamegraph
FlameGraphs.NodeData
```

## Rendering flame graphs

```@docs
flamepixels
flametags
FlameColors
StackFrameCategory
FlameGraphs.default_modcat
FlameGraphs.default_loccat
```

## I/O

```@docs
FlameGraphs.save
FlameGraphs.load
```
